Welcome

>> For asix 6 users

www.asix.com.pl

Moduł AsAlarm -

Interactive analysis of historical alarm event logs of asix system applications

Doc. Nr ENH6101

Version: 04-10-2010


1. AsAlarm functional specification

AsAlarm is an application providing tools for in-depth analysis of alarms generated by the monitored site and of other data relating to alarm system operation. The application meets the EEMUA (The Engineering Equipment and Materials Users Association) guidelines No 191. This document sets out the principles for correct design and operation of the alarm system. The primary conclusion of this publication is that in order to sustain high efficiency and reliability of the alarm system, its status needs to be regularly monitored and analysed.

AsAlarm allows two-level alarm analysis:

- assessment of the design of alarm system structure for a specific application;

- analysis of alarm events logged at the site;

Alarm information management is implemented with the use of:

  • historical event table,

  • graphs of selected alarm events,

  • dynamic analysis allowing a variety of statistical calculations using event log data,

  • statistical analysis reflecting the alarm definitions database structure.

The AsAlarm application uses an interface similar to the Multi Document Interface (MDI), which allows creating many tabs in the application's main window. Each tab has its own independent set of filters and data presentation area (table, graph, analysis).

AsAlarm settings, in particular database access path, filter values as well as other options are saved in the project file, in XML format. The set of analysed alarms is subject to preliminary selection criteria defined by the common event filter. Within a single AsAlarm project file, it is possible to create many tabs in the application's main window, where each contains its own set of filtering options. This mechanism allows creating a single project allowing analysis of alarms within different periods of time defined in separate tabs, that's without the need to redefine filtering conditions each time in order to obtain the results for a given period of time.

Two versions of the AsAlarm application are available: standard desktop and Web-based. Functionality of both versions is the same, however the desktop version has an option of selecting event and alarm definitions databases. In the web-based version of the application the parameters allowing access to these databases are encoded in AsAlarm web page interface (the administrator configures the application before publication on the web; configuration can be performed using the Architect application).

Figure: AsAlarm - Main window of Web-based applications.

Figure: AsAlarm - Main window of desktop application.


2. AsAlarm application requirements

Alarm definitions / Alarm event log

Alarm definitions analysed by the AsAlarm application must be stored in SQL or MDB format in asix system application variable definitions database, while alarm event log must be saved on an SQL Server. In this field there is a possibility of converting asix system alarm event logs available in a binary format (al??????.log files) to SQL format using the AlarmLogConverter.exe application, available as a part of asix package. Also possible is current logging of alarm events in an SQL database for subsequent analysis using the AsAlarm application - such logging is conducted simultaneously with logging of alarm events in al??????.log archive log files.

AsAlarm requires MS SQL Server 2008 database files. The asix system is compatible with both Reporting Services offered by the free Express version and the services made available in full versions of MS SQL Server 2008.

Web-based AsAlarm

An Internet browser such as Internet Explorer or Firefox with IE Tab add-on installed, is required to access web-based version of the AsAlarm application.


3. Alarm definitions database - configuration

As standard, alarm definitions are stored in alarm.def text file. The use of different filenames is possible by defining the Names of files parameter (configuration of the application's XML file using the Architect application: Architect >Fields and Computers > Alarms System module > Alarms/Alarms base tab, assuming that alarm definitions database is based on alarm definitions text files - Architect > Databases > Alarm definitions base > Type tab > Text files with alarm definitions are edited by the developer… option). Alarm descriptions can be located in several definition files. Internal alarms are identified by a number. Up to 65,535 different alarms can be defined. There is no need to number the alarms sequentially. For example, numbering of a one group of alarms begins with 1,000, while another (different source or type) begins with a number 30,000.

As standard, alarm group definitions are stored in group.def text file. The use of different filenames is possible by defining the filenames parameter (configuration of the application's XML file using the Architect application: Architect >Fields and Computers > Alarms System module > Alarms/Alarms base - groups tab, assuming that alarm definitions database is based on alarm definitions text files - Architect > Databases > Alarmbase > Type tab > Text files with alarm definitions are edited by the developer… option).

See more:

'Asix – functionality and operation rules', chapt. '12. Alarm System';

'Architect - Interactive application configuration environment. Handling of VarDef Definition Base', chapt. '3.9. Configuration of alarm system'.

For the needs of the AsAlarm application, alarm definitions must be retrieved from variable definitions database in MS SQL or MDB format. Practically, this requires suitable configuration of alarm definitions database and generating alarm definitions as a part of the existing variable definitions database.

In order to append alarm definitions and alarm groups definitions to variable definitions database:

1. Prepare alarm definitions in an Excel spreadsheet

NOTE: Appending alarm definitions to the variable definitions database requires creating an Excel spreadsheet containing alarm definitions and another spreadsheet containing alarm group definitions. In the event that alarm definitions are available in text files, these should be converted to an Excel spreadsheet using the following procedure:

- run Microsoft Excel application,

- select from the menu bar Data->From text,

- change file type to ‘All Files’, and then open the definition file (.adf or .gdf extension),

- select delimited data file; file origin must be set to '1250 Central European (Windows)', and click next,

- check ‘comma' on the list of delimiters and click OK.

2. Set suitable alarm definitions database operation mode:

Architect > Databases > Alarmbase > Type tab > Alarm definitions base is generated from a spreadsheet / Add alarm definitions to variable definition base

3. Add Excel spreadsheets containing the alarm and alarm group definitions to data sources in alarm definitions database:

Architect > Databases > Alarmbase > Data sources tab > option: Add data source: Excel

4. Generate alarm definitions database (this will append alarm and alarm groups definitions to the existing variable definitions database):

Architect > Databases > Alarmbase > Data sources tab > option: Operations: Generate.

NOTE: Each update of variable definitions database (generating it again) requires the alarm and alarm group definitions to be generated again and appended to variable definitions database using the command:

Architect > Databases > Alarmbase > Data sources tab > option: Operations: Generate

Figure: Architect - appending alarm definitions database to the variable definitions database.

Figure: Architect - alarm definitions database generator.


4. Alarm event log database - configuration

Current status and alarm history of the asix system are stored in disk files. Alarm files are stored in 'alarms' subfolder of the start folder (unless other location is defined). The file alarms.act contains information concerning all active alarms. Alarm log consists of a set of files matching the expression al??????.log.Each file contains alarm events from a given day. Relevant date replaces the ?????? string of characters, and it contains the day, month and year. Alarm logs can be stored indefinitely. It is possible to define how long the files are stored.

The AsAlarm application requires the alarm log to be stored in an SQL database.

There is an option of converting asix system binary alarm event log files (al??????.log files) to SQL database format. AlarmLogConverter.exe application enclosed with asix 6 package can be used for this purpose.

The AsAlarm application allows current logging of alarm event in an SQL database. This requires asix system application XML file to be appropriately configured, and saving of on-line generated alarm event data in an SQL database to be unblocked.

(see:

- 4.1. Starting alarm event logging with binary file conversion - to ensure continuity of alarm logging between current logging and the historical event log

- 4.2. Starting on-line alarm event logging - when there is no historical log, alarm logging begins from current moment)


4.1. Starting alarm event logging with binary file conversion

4.1. Starting alarm event logging with binary file conversion to SQL database format

The conversion of asix system binary alarm event log files to SQL database format can be performed using the AlarmLogConverter.exe application, which is enclosed with asix 6 package as standard.

Figure: AlarmLogKonwerter application's main window.

Listed below are options required to start alarm event logging and conversion:

Asix application – refers to an alarm source

Configuration file – requires specifying the asix application XML configuration file for asix versions 5 or 6, or an INI file for older versions of asix

Variant – application variant dedicated to a specific computer or site area (several computers operating with a given application at a site)

Database settings – parameters pertaining to alarm database location and target name

Server name – MS SQL Server 2008 server name

Database name - MS SQL alarm event database name

Authorization mode – SQL Server database user authorisation mode: Windows or Windows and SQL Server (directly through login and password)

Database administration – includes options and commands associated with database administration

Authorization mode – SQL Server database admin authorisation mode: Windows or Windows and SQL Server (directly through login and password)

Check database – checks if the database exists and is valid.

Create database - creates a new alarm database

Drop database – deletes alarm database

Clear database – clears database for another conversion

Operation – conversion procedure commands

Unlock – unlocks current online alarm event logging in an SQL database until EXPORT_CHANNEL option is switched on, which allows asix to create buffer files containing log information; unlocking allows saving to an SQL database of data collected in the buffer files.

Start – starts the conversion of al??????.log alarm files to MS SQL Server 2008 database format

Cancel – cancels the conversion process (conversion will not be performed)

The procedure for starting alarm event logging with binary file conversion to SQL database format.

In order to convert al??????.log files to SQL database format and start current alarm event logging without losing alarm event time information in the conversion process, follow the procedure below carefully:

1. In order to create a blank SQL database using the AlarmLogKonwerter converter application:

a. start AlarmLogKonwerter application

b. select application XML file and indicate computer station which will be the source of alarm log files

c. declare SQL server name and the target alarm database name

d. select user and admin authorization mode

e. click Create database

2. The selection of current alarm event logging - until MS SQL logging is unlocked, events are logged in buffer files:

a. open the operating asix application configuration file using the Architect application

b. select options in the tab Architect > Alarms System > Archive tab > Microsoft SQL Server tab:

Name of Microsoft SQL Server - name of MS SQL Server 2008 of alarm event database,

Database name - MS SQL alarm event database name.

c. Save changes in application configuration file

3. Restart the application

4. Converting al??????.log files into SQL database format:

a. Switch to AlarmLogKonwerter application and click Start in Operation category.

5. Unlocking saving to an SQL database of an online generated alarm event log:

a. once the conversion has completed, go to Operation category and click Unlock in AlarmLogKonwerter application.


4.2. Starting online alarm event logging

Selecting current alarm logging is performed as follows:

(Until MS SQL logging is unlocked, events are logged in buffer files:)

a. open the operating asix application configuration file using the Architect application

b. select options in the tab Architect > Alarms System > Archive tab > Microsoft SQL Server tab:

Name of Microsoft SQL Server - name of MS SQL Server 2008 of alarm event database,

Database name - MS SQL alarm event database name.

c. Save changes in application configuration file

d. Restart the application

Unlock saving to an SQL database of an online generated alarm event log:

Open the database where alarm events will be logged and go to Operation tab and click Unlock in AlarmLogKonwerter application.


5. Starting AsAlarm application

Desktop AsAlarm application

Desktop AsAlarm application can be started by going to Start > Programs > Asix or by clicking AsAlarm.exe file directly. The file is located in asix package main folder.

Figure: Desktop AsAlarm application.

Web-based application version

The AsAlarm can be started using the Internet Explorer browser by typing in the URL:

http://(computer_name)/AsAlarmNet/index.htm

computer name should be replaced with web server name or an IP address. AsAlarmNet is the server folder name, which is made available on the web. By default, during installation of asix package, the web-based version of the AsAlarm application is saved in the main folder.

Application instance is stateless. This means that multiple browser windows can be started and operated independently.

In order for the AsAlarm application to operate as intended, browser security settings must be configured correctly. To set up the settings, start BrowserConfigurator.exe application and enter AsAlarm IP address as one of the trusted sites. BrowserConfigurator.exe is available on AsPortal application.

Figure: Web-based AsAlarm version


5.1. Selecting databases for local AsAlarm version

Alarm event database is selected using the ‘Database selection’ window accessed through Open option from AsAlarm main menu.

Figure: MS SQL alarm event database selection window.

Alarm definitions database is selected using the ‘Database selection’ window accessed through Open option from AsAlarm main screen.

Figure: Alarm definitions database selection window.


5.2. Configuration of database access path for web-based AsAlarm

The AsAlarm application allows analysis of variable definitions and historical alarm data. The web-based AsAlarm application reads database access path from the website saved on the server (i.e index.htm).

Database location is indicated in the following HTML tags:

<head>

<meta name="AlarmsArchiveServerName" id="AlarmsArchiveServerName" content="(local)">

- Microsoft SQL Server 2008 instance in the format: "server_name\instance_name"

<meta name="AlarmsArchiveDatabaseName" id="AlarmsArchiveDatabaseName" content="AsAlarm">

- name of the database containing alarm log

</head>

Alarm event definitions database access path is defined in the following HTML tags:

<head>

<meta name="AlarmsDef" id="AlarmsDef" content="Baza_zmiennych.mdb">

- Microsoft Access database name (*.mdb) Microsoft SQL Server database access path in the format:

"server_name\instance_name\database_name"

</head>

In order to change database access path, change the 'content' attribute in the tags indicated above.

NOTE: It is possible to configure variable definitions and historical alarm database access path using a configuration wizard available from the Architect application. This allows updating the 'index.htm' configuration file based on asix system application configuration. The configuration wizard copies variable definitions database file containing alarm definitions (when it is MDB format) to AsAlarm application folder.

In order to configure database access path for web-based AsAlarm using the Architect application:

1. Start the Architect and open asix system application configuration file.

2. Start web application configuration wizard:

Architect > Application menu > Configure Internet Applications ... > AsAlarm/Configuration tab

3. Click Configure


6.1. Main window

AsAlarm main window consists of the following: toolbar, tab list, filter options, table/graph/analyses presentation area. Window title bar shows current project file name.

Figure: AsAlarm application's main window.


6.2. Main menu

The application's main menu is a ribbon characteristic of all new Microsoft applications. All commands have been organised into two main tabs: Tools and View. Within each tab all the buttons have been grouped into logical sections:

Tools

File section commands allowing to create, open and save the project files in XML format. Open and save dialog windows have active filter to show the *.XML extension files only.

Data section commands to refresh (for instance when filtering options change) or print data

Tabs section commands for tab management

Chart section commands for chart creation and management

Alarm Events Archive - section available to desktop AsAlarm version; allows selecting an alarm events archive

Alarm Definitions Base - section is available to desktop AsAlarm version; allows selecting an alarm definitions database

Figure: ‘Tools’ tab commands.

View

View tab allows changing the appearance of the interface. It allows selecting from a list of application colour schemes. Once selected, a new colour scheme is applied.

Figure: ‘View’ tab commands.


6.3. Managing tabs

The application uses an interface similar to the Multi Document Interface (MDI), which allows creating many tabs in the application's main window.

Each tab has its own independent set of filters and data presentation area (table, graph, analysis).

Selecting the command Tabs > New Tab will add a new tab with a default name. The default name has the "Tab" prefix, which is followed by a sequence of numbers starting with "1."

To change the name of the active tab go to Tabs > Rename, which will open a text input window.

Tab layout can be optimised using the drag-and-drop technique. A tab can be removed using the red button shown by the active tab name.

Figure: AsAlarm windows with a number of created tabs.


6.4. Event filter

Event filter can be applied to tables, charts and dynamic analysis. Advanced filtering allows selecting alarms based on:

- identifiers (identifier range or list),

- text,

- group,

- type,

- status (predefined or user-defined),

- start and end time,

- acknowledgement options (time, operator, workstation).

Filtering options allow absolute time entry thanks to the support for OPC notation.

Figure: Event filter viewer with expanded 'Status' and 'Event Time' groups.


6.5. Table

Historical events table allows displaying all information stored in the alarm event database. Table columns reflect the columns in the database.

The table presents all events meeting specific filtering criteria. The layout, sequence and viewing of the columns are fully configurable. Furthermore, the user has at its disposal the mechanisms inbuilt in the table, including: grouping, additional filtering and sorting. The figure below presents a table with active grouping (1) and sorting, with an open column selection window (2).Status bar (3) at the bottom of the table shows the following information: Total number of events, Number of selected events, duration of selected events.

Additionally, all columns such as date/time are available in two versions: presenting local or UTC time.

Figure. Alarm events table

The table has its own context menu activated through selected rows (alarm events), allowing:

  • showing table view containing selected events only,

  • adding events to an existing chart or creating a new chart with the selected events.

NOTE: The table is limited to display a maximum of 100,000 rows. In the event of an attempt to display a greater number of records, a relevant message is displayed (once during the application launch) and 100,000 of the latest alarm events are retrieved. A yellow warning triangle will be displayed on the applications status bar.


6.6. Chart

Chart allows presentation of alarm events using the step graph. It consists of three parts, data range panel (1), data presentation area (2) and legend panel (3). Both panels can be collapsed in order to enlarge the data presentation area. Using individual tabs, multiple charts displaying different sets of data can be created. Chart names and sequence can be freely modified by the user, much the same as is the case for the main application tabs.

Alarm events can be added to a chart in two ways. The legend features buttons opening a window for selecting alarms from alarm definitions database. Events can be also added from the table, by selecting a number of rows and calling the context menu. The displayed chart series can be removed using the legend.

Taking active filters into account, chart range is determined by the start and end points of the retrieved events. The data range panel can be used to move across the chart area. The user can zoom in and out, go forwards or backwards and select specific points of the series. Creating user-defined charts is also possible.

The legend panel presents essential event information. Legend row colours correspond to series of data on the graph. If the legend is hidden, event identifiers will be displayed on the chart.

When the mouse pointer hovers above the series plot, the event's label and timestamp are displayed. The entire chart and an example of this functionality are shown on the figure below.

It is possible to move around on the chart:

- zooming in and out (using the [image] [image] buttons or using the magnifying glass which can be selected by hovering the mouse pointer above the chart while holding down the Shift / Ctrl keys),

- shifting left or right (using the [image] [image]; [image] [image] buttons),

- positioning the chart's starting point to next occurrence of a given event selected in the legend (using the [image] buttons),

Figure: Alarm event chart.

NOTE: Similarly as the table, charts are limited to display a maximum of 5,000 points. In the event that the total number of points in all series exceeds this limit, a given series will not be plotted. A relevant message is displayed (once during the application launch) and a yellow warning triangle will be displayed on the applications status bar.


6.7. Dynamic analysis

The analytic section is divided into static and dynamic analysis tabs.

Dynamic analysis is presented in the form of a pivot table. This means that the user is able to create the required data set. Columns, rows and data area content can be selected.

The dynamic analysis allows viewing of the following statistical information calculated based on alarm event log analysis:

  • event occurrence distribution (number, percentage),

  • event duration,

  • average time to acknowledge,

  • number of terminated alarms,

  • number of acknowledged alarms,

  • identification of most frequently occurring events,

  • identification of the longest events.

These statistics can be calculated and grouped by type, group and alarm identifier. Table view can be rearranged by selecting the visible fields, columns and reorganising the whole table.

Combining these capabilities with the simple sorting mechanism allows in-depth analysis of the presented data.

Figure: Dynamic analysis


6.8. Static analysis

Alarm definitions database analysis is presented in the Static analysis tab. The user is given information on the number of alarms, proportional and quantitative distribution of alarm definitions, divided into groups and types. The results are presented in the form of a table or a chart.

NOTE: There is an option of sorting the rows by column, which is also reflected in the sequence of bars on the chart - the bars are sorted in ascending or descending order depending on how table rows are sorted.

Figure: Static analysis


6.9. Printouts

The application allows printing of data from tables, charts and analyses. Select Print to preview the page to be printed out. A report prepared in this way (shown on the figure below) is preformatted, i.e. it has a header (1), printout date (2), page numbering (3) and the company footer (4). The header shows current tab name and chart title. All these parameters can be modified by the user in the print preview window.

The report also shows text description of active filters (5). The default printout orientation is landscape.

Figure: Chart printout (1).

Figure: Chart printout (2).


AsAlarm_28_06_2010_do_tłumaczenia_na_eng_EN-GB

AsAlarm

Interactive analysis of historical alarm event logs of asix system applications

Table of contents

1. AsAlarm functional specification

2. AsAlarm application requirements

3. Alarm definitions database - configuration

4. Alarm event log database - configuration

4.1. Starting alarm event logging with binary file conversion to SQL database format.

4.2. Starting online alarm event logging

5. Starting AsAlarm application

5.1. Selecting databases for local AsAlarm version

5.2. Configuration of database access path for web-based AsAlarm

6. Using the application

6.1. Main window..

6.2. Main menu

6.3. Managing tabs

6.4. Event filter

6.5. Table

6.6. Chart

6.7. Dynamic analysis

6.8. Static analysis

6.9. Printouts